// u_c_person
// 2013-02-09

// -- (C) John COLIBRI 2013
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_22_ioc;
  interface
    uses Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls,
        Forms, Dialogs, StdCtrls, ExtCtrls;

    type TForm1=
             class(TForm)
               Panel1: TPanel;
               Panel2: TPanel;
               Splitter1: TSplitter;
               Memo1: TMemo;
               exit_: TButton;
               clear_: TButton;
    constructor_injection_: TButton;
               b_: TButton;
               procedure exit_Click(Sender: TObject);
               procedure clear_Click(Sender: TObject);
               procedure FormCreate(Sender: TObject);
               procedure constructor_injection_Click(Sender: TObject);
               procedure b_Click(Sender: TObject);
               procedure c_Click(Sender: TObject);
               procedure d_Click(Sender: TObject);
               procedure e_Click(Sender: TObject);
               procedure f_Click(Sender: TObject);
               procedure g_Click(Sender: TObject);
               private
               public
             end; // TForm1
    var Form1: TForm1;
  implementation
    uses u_display_simple, u_using_ioc, u_c_auxiliary;

    {$R *.dfm}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.constructor_injection_Click(Sender: TObject);
      var l_i_dependency: i_dependency;
          l_c_consumer: c_consumer;
      begin
        l_i_dependency:= c_dependency_injector.f_i_dependency('u_c_auxiliary.c_auxiliary_one');
        if l_i_dependency= Nil
          then display('NIL');

        l_c_consumer:= c_consumer.create_consumer(l_i_dependency);
        try
          l_c_consumer.do_compute;
        finally
          l_c_consumer.Free;
        end;
      end; // constructor_injection_Click

    procedure TForm1.b_Click(Sender: TObject);
      var l_c_auxiliary_one: c_auxiliary_one;
      begin
        l_c_auxiliary_one:= c_auxiliary_one.Create;

      end; // b_

    procedure TForm1.c_Click(Sender: TObject);
      begin

      end; // c_

    procedure TForm1.d_Click(Sender: TObject);
      begin

      end; // d_

    procedure TForm1.e_Click(Sender: TObject);
      begin

      end; // e_

    procedure TForm1.f_Click(Sender: TObject);
      begin

      end; // f_

    procedure TForm1.g_Click(Sender: TObject);
      begin

      end; // g_

    end.
